base-files: implement -T (--test) sysupgrade parameter to verify image without actual...
[openwrt.git] / package / base-files / files / sbin / sysupgrade
index fcf01b0..49c34b8 100755 (executable)
@@ -1,5 +1,5 @@
 #!/bin/sh
-. /etc/functions.sh
+. /lib/functions.sh
 
 # initialize defaults
 RAMFS_COPY_BIN=""      # extra programs for temporary ramfs root
@@ -11,7 +11,11 @@ export SAVE_OVERLAY=0
 export DELAY=
 export CONF_IMAGE=
 export CONF_BACKUP=
+export CONF_RESTORE=
+export NEED_IMAGE=
 export HELP=0
+export FORCE=0
+export TEST=0
 
 # parse options
 while [ -n "$1" ]; do 
@@ -22,8 +26,11 @@ while [ -n "$1" ]; do
                -q) export VERBOSE="$(($VERBOSE - 1))";;
                -n) export SAVE_CONFIG=0;;
                -c) export SAVE_OVERLAY=1;;
-               -b|--create-backup) export CONF_BACKUP="$2"; shift;;
+               -b|--create-backup) export CONF_BACKUP="$2" NEED_IMAGE=1; shift;;
+               -r|--restore-backup) export CONF_RESTORE="$2" NEED_IMAGE=1; shift;;
                -f) export CONF_IMAGE="$2"; shift;;
+               -F|--force) export FORCE=1;;
+               -T|--test) export TEST=1;;
                -h|--help) export HELP=1; break;;
                -*)
                        echo "Invalid option: $1"
@@ -40,32 +47,43 @@ export CONF_TAR=/tmp/sysupgrade.tgz
 export ARGV="$*"
 export ARGC="$#"
 
-[ -z "$ARGV" -a -z "$CONF_BACKUP" -o $HELP -gt 0 ] && {
+[ -z "$ARGV" -a -z "$NEED_IMAGE" -o $HELP -gt 0 ] && {
        cat <<EOF
-Usage: $0 [options] <image file or URL>
+Usage: $0 [<upgrade-option>...] <image file or URL>
+       $0 [-q] [-i] <backup-command> <file>
 
-Options:
+upgrade-option:
        -d <delay>   add a delay before rebooting
        -f <config>  restore configuration from .tar.gz (file or url)
        -i           interactive mode
        -c           attempt to preserve all changed files in /etc/
-       -b / --create-backup <file>
-                    create .tar.gz of files specified in sysupgrade.conf
-                    then exit. Does not flash an image. If file is '-',
-                    i.e. stdout, verbosity is set to 0 (i.e. quiet).
        -n           do not save configuration over reflash
+       -T | --test
+                    Verify image and config .tar.gz but do not actually flash.
+       -F | --force
+                    Flash image even if image checks fail, this is dangerous!
        -q           less verbose
        -v           more verbose
-       -h / --help  display this help
+       -h | --help  display this help
+
+backup-command:
+       -b | --create-backup <file>
+                    create .tar.gz of files specified in sysupgrade.conf
+                    then exit. Does not flash an image. If file is '-',
+                    i.e. stdout, verbosity is set to 0 (i.e. quiet).
+       -r | --restore-backup <file>
+                    restore a .tar.gz created with sysupgrade -b
+                    then exit. Does not flash an image. If file is '-',
+                    the archive is read from stdin.
 
 EOF
        exit 1
 }
 
-[ -n "$ARGV" -a -n "$CONF_BACKUP" ] && {
+[ -n "$ARGV" -a -n "$NEED_IMAGE" ] && {
        cat <<-EOF
-               -b/--create-backup does not perform a firmware upgrade. Do not
-               specify both -b and a firmware image.
+               -b|--create-backup and -r|--restore-backup do not perform a firmware upgrade.
+               Do not specify both -b|-r and a firmware image.
        EOF
        exit 1
 }
@@ -122,6 +140,12 @@ if [ -n "$CONF_BACKUP" ]; then
        exit $?
 fi
 
+if [ -f "$CONF_RESTORE" ] || [ "$CONF_RESTORE" = "-" ]; then
+       [ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""
+       tar -C / -x${TAR_V}zf "$CONF_RESTORE"
+       exit $?
+fi
+
 type platform_check_image >/dev/null 2>/dev/null || {
        echo "Firmware upgrade is not implemented for this platform."
        exit 1
@@ -129,8 +153,13 @@ type platform_check_image >/dev/null 2>/dev/null || {
 
 for check in $sysupgrade_image_check; do
        ( eval "$check \"\$ARGV\"" ) || {
-               echo "Image check '$check' failed."
-               exit 1
+               if [ $FORCE -eq 1 ]; then
+                       echo "Image check '$check' failed but --force given - will update anyway!"
+                       break
+               else
+                       echo "Image check '$check' failed."
+                       exit 1
+               fi
        }
 done
 
@@ -146,21 +175,28 @@ if [ -n "$CONF_IMAGE" ]; then
        get_image "$CONF_IMAGE" "cat" > "$CONF_TAR"
        export SAVE_CONFIG=1
 elif ask_bool $SAVE_CONFIG "Keep config files over reflash"; then
-       do_save_conffiles
+       [ $TEST -eq 1 ] || do_save_conffiles
        export SAVE_CONFIG=1
 else
        export SAVE_CONFIG=0
 fi
 
+if [ $TEST -eq 1 ]; then
+       exit 0
+fi
+
 run_hooks "" $sysupgrade_pre_upgrade
 
+ubus call system upgrade
+touch /tmp/sysupgrade
+
 kill_remaining TERM
 sleep 3
 kill_remaining KILL
 
 if [ -n "$(rootfs_type)" ]; then
        v "Switching to ramdisk..."
-       run_ramfs '. /etc/functions.sh; include /lib/upgrade; do_upgrade'
+       run_ramfs '. /lib/functions.sh; include /lib/upgrade; do_upgrade'
 else
        do_upgrade
 fi